"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.adminValidaterMiddleWare_HOC = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var __sysName = '';
var __ruleValidateUrl = '';

var initJWTValidater = function initJWTValidater(_ref) {
  var serviceName = _ref.serviceName,
      ruleValidateUrl = _ref.ruleValidateUrl;
  __sysName = serviceName;
  __ruleValidateUrl = ruleValidateUrl;
};

var jwtValidater =
/*#__PURE__*/
function () {
  var _ref3 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(_ref2, adminMiddleWareConfig, req, res) {
    var categoryName, sysName, ruleName, fullUrl, _adminMiddleWareConfi, rulecenterHomeUrl, _adminMiddleWareConfi2, validatorEndPoint, jwtoken, _fullUrl, redurl, frontReq, query, res2, jsonResult, _redurl, _redurl2;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          categoryName = _ref2.categoryName, sysName = _ref2.sysName, ruleName = _ref2.ruleName;
          fullUrl = 'https://' + req.get('host') + req.originalUrl;
          _adminMiddleWareConfi = adminMiddleWareConfig.rulecenterHomeUrl, rulecenterHomeUrl = _adminMiddleWareConfi === void 0 ? req.get('host').indexOf("gankao.com") > -1 ? "//main.admin.gankao.com" : "//main.admin.gankaotest2.com" : _adminMiddleWareConfi, _adminMiddleWareConfi2 = adminMiddleWareConfig.validatorEndPoint, validatorEndPoint = _adminMiddleWareConfi2 === void 0 ? req.get('host').indexOf("gankao.com") > -1 ? 'https://api.gankao.com/api-rulecenter/gkrulemanager/validate' : 'https://api.gankaotest2.com/api-rulecenter/gkrulemanager/validate' : _adminMiddleWareConfi2;
          jwtoken = req ? (req.cookies || {}).jwtoken : '';

          if (jwtoken) {
            _context.next = 9;
            break;
          }

          _fullUrl = 'https://' + req.get('host') + req.originalUrl;
          redurl = "".concat(rulecenterHomeUrl, "/user/login?redirect=").concat(encodeURIComponent(_fullUrl));
          setImmediate(function () {
            res.redirect(redurl);
          });
          return _context.abrupt("return", false);

        case 9:
          frontReq = {
            ___ip: req.headers['x-forwarded-for'] || req.connection && req.connection.remoteAddress || req.socket && req.socket.remoteAddress || req.connection.socket && req.connection.socket.remoteAddress || '',
            headers: req.headers,
            cookies: req.cookies
          };
          query = {
            method: 'POST',
            rejectUnauthorized: false,
            headers: {
              'Accept': 'application/json, text/plain, */*',
              'Content-Type': 'application/json'
            },
            json: true,
            body: JSON.stringify({
              jwtoken: jwtoken,
              sysName: sysName || __sysName,
              categoryName: categoryName,
              ruleName: ruleName,
              frontReq: frontReq
            })
          };
          _context.next = 13;
          return (0, _isomorphicFetch["default"])(validatorEndPoint, query);

        case 13:
          res2 = _context.sent;
          _context.next = 16;
          return res2.json();

        case 16:
          jsonResult = _context.sent;

          if (process.env.DEBUG == 1) {
            console.log("".concat(validatorEndPoint, " result"), jsonResult);
          }

          if (!res2.err) {
            _context.next = 26;
            break;
          }

          _redurl = "".concat(rulecenterHomeUrl, "/user/noaccess?gankaoUID=").concat(encodeURIComponent(fullUrl), "&target=").concat(encodeURIComponent(categoryName + "/" + ruleName), "&resean=").concat(encodeURIComponent(JSON.stringify(res2.err)));
          setImmediate(function () {
            res.redirect(_redurl);
          }); //}, 访问功能：${this.props.target}，拒绝原因：${this.props.resean

          console.error('validater err');
          console.error(res.err);
          return _context.abrupt("return", false);

        case 26:
          if (res.result.canAccess) {
            _context.next = 32;
            break;
          }

          //{canAccess: true, gankaoUID: reguserId}
          _redurl2 = "".concat(rulecenterHomeUrl, "/user/noaccess?gankaoUID=").concat(encodeURIComponent(res.result.gankaoUID), "&target=").concat(encodeURIComponent(categoryName + "/" + ruleName), "&resean=").concat(encodeURIComponent("没有访问权限"));
          setImmediate(function () {
            res.redirect(_redurl2);
          });
          return _context.abrupt("return", false);

        case 32:
          return _context.abrupt("return", true);

        case 33:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));

  return function jwtValidater(_x, _x2, _x3, _x4) {
    return _ref3.apply(this, arguments);
  };
}();

var adminValidaterMiddleWare_HOC = function adminValidaterMiddleWare_HOC(adminConsoleConfig) {
  return function (_ref4) {
    var categoryName = _ref4.categoryName,
        sysName = _ref4.sysName,
        ruleName = _ref4.ruleName;
    return function (req, res, next) {
      jwtValidater({
        categoryName: categoryName,
        sysName: sysName,
        ruleName: ruleName
      }, adminConsoleConfig, req, res).then(function (result) {
        if (result === true) {
          next();
        } else {//内部已经redirect到/noaccess提示页
        }
      })["catch"](function (e) {
        console.error(e.stack);
      });
    };
  };
};

exports.adminValidaterMiddleWare_HOC = adminValidaterMiddleWare_HOC;