"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setting_redisConfig = exports.getting_redisConfig = exports.getRedisClient = exports.__setGankaoWXAuthToken = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _redis = _interopRequireDefault(require("redis"));

var _moment = _interopRequireDefault(require("moment"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _GKErrors_Inner = require("./GKErrors_Inner");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _redisClient;

var _redisConfig;

var _redisClient_inited = false;

var setting_redisConfig = function setting_redisConfig(redisConfig) {
  (function () {
    if (!_redisConfig) {
      _redisConfig = redisConfig;
      console.log("class2api \u5185\u7F6Eredis\u914D\u7F6Econfig\u521D\u59CB\u5316\u6210\u529F\uFF01");
    }

    var _ = getRedisClient();
  })();
};

exports.setting_redisConfig = setting_redisConfig;

var getting_redisConfig =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee() {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          return _context.abrupt("return", _redisConfig);

        case 1:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));

  return function getting_redisConfig() {
    return _ref.apply(this, arguments);
  };
}();

exports.getting_redisConfig = getting_redisConfig;

var _init_redisClient = function _init_redisClient() {
  return new _bluebird["default"](function (resolve, reject) {
    var _redisConfig2 = _redisConfig,
        redis_cache_key_prefx = _redisConfig2.cache_prefx;
    if (!redis_cache_key_prefx) throw _GKErrors_Inner.GKErrors._SERVER_ERROR("class2api\u7684getRedisClient\u521D\u59CB\u5316\u65F6\u62A5\u9519\uFF0C\u672A\u8BBE\u5B9Aredis_cache_key_prefx\u503C");

    if (!_redisConfig) {
      if (process.env.NODE_ENV === "production") {
        reject("Error redis\u914D\u7F6E\u4FE1\u606F\u5C1A\u672A\u8BBE\u7F6E\uFF08\u8BF7\u8C03\u7528setting_redisConfig\uFF09!!, Cacheable\u7B49\u7F13\u5B58\u4FEE\u9970\u5668\u5C06\u5931\u6548");
      } else {
        throw new Error("redis\u914D\u7F6E\u4FE1\u606F\u5C1A\u672A\u8BBE\u7F6E\uFF08\u8BF7\u8C03\u7528setting_redisConfig\uFF09");
      }
    }

    _redisClient = _redis["default"].createClient({
      host: _redisConfig.host,
      port: _redisConfig.port
    });

    _bluebird["default"].promisifyAll(_redisClient);

    console.log("\u94FE\u63A5Redis\u670D\u52A1\u5668 on ".concat(_redisConfig.host, ":").concat(_redisConfig.port, " ... ..."));

    _redisClient.on("error",
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2(err) {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              console.error('redis event: error...', err.message);
              reject("Error " + err);

            case 2:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }());

    _redisClient.on("ready",
    /*#__PURE__*/
    function () {
      var _ref3 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee3(info) {
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              console.error('redis event: ready ...', info);

            case 1:
            case "end":
              return _context3.stop();
          }
        }, _callee3);
      }));

      return function (_x2) {
        return _ref3.apply(this, arguments);
      };
    }());

    _redisClient.on("reconnecting",
    /*#__PURE__*/
    function () {
      var _ref4 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee4(info) {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              console.error('redis event: reconnecting ...', info);

            case 1:
            case "end":
              return _context4.stop();
          }
        }, _callee4);
      }));

      return function (_x3) {
        return _ref4.apply(this, arguments);
      };
    }());

    _redisClient.on("end",
    /*#__PURE__*/
    function () {
      var _ref5 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee5(info) {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) switch (_context5.prev = _context5.next) {
            case 0:
              console.error('redis event: end ...', info);

            case 1:
            case "end":
              return _context5.stop();
          }
        }, _callee5);
      }));

      return function (_x4) {
        return _ref5.apply(this, arguments);
      };
    }());

    _redisClient.on("warning",
    /*#__PURE__*/
    function () {
      var _ref6 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee6(err) {
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) switch (_context6.prev = _context6.next) {
            case 0:
              console.error('redis event: warning ...', info);

            case 1:
            case "end":
              return _context6.stop();
          }
        }, _callee6);
      }));

      return function (_x5) {
        return _ref6.apply(this, arguments);
      };
    }());

    var onAuthDone =
    /*#__PURE__*/
    function () {
      var _ref7 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee7() {
        var key, avalue, deleted;
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) switch (_context7.prev = _context7.next) {
            case 0:
              _redisClient_inited = true;
              console.log("\u94FE\u63A5Redis\u670D\u52A1\u5668 on ".concat(_redisConfig.host, ":").concat(_redisConfig.port, " ... ...\u6210\u529F!")); //  this key will expires after 10 seconds

              key = '__test_redis'; // 测试

              _context7.next = 5;
              return _redisClient.setAsync(key, JSON.stringify({
                hello: "world"
              }), 'EX', 10);

            case 5:
              console.log("\u6D4B\u8BD5\uFF0C\u521B\u5EFA redis key:".concat(key));
              _context7.next = 8;
              return _redisClient.getAsync(key);

            case 8:
              avalue = _context7.sent;
              console.log("\u6D4B\u8BD5\uFF0C\u8BFB\u53D6 redis key:".concat(key, ",value:").concat(avalue));
              _context7.next = 12;
              return _redisClient.delAsync(key);

            case 12:
              deleted = _context7.sent;
              console.log("\u6D4B\u8BD5\uFF0C\u5220\u9664\u4E86redis key:".concat(key, ",").concat(deleted)); //

              _context7.t0 = console;
              _context7.t1 = "\u6D4B\u8BD5\uFF0C\u81EA\u589E\u6570\u5B57\uFF1A";
              _context7.next = 18;
              return _redisClient.incrAsync("incr_test_1");

            case 18:
              _context7.t2 = _context7.sent;
              _context7.t3 = _context7.t1.concat.call(_context7.t1, _context7.t2);

              _context7.t0.log.call(_context7.t0, _context7.t3);

              _context7.t4 = console;
              _context7.t5 = "\u6D4B\u8BD5\uFF0C\u81EA\u589E\u6570\u5B57\uFF1A";
              _context7.next = 25;
              return _redisClient.incrAsync("incr_test_1");

            case 25:
              _context7.t6 = _context7.sent;
              _context7.t7 = _context7.t5.concat.call(_context7.t5, _context7.t6);

              _context7.t4.log.call(_context7.t4, _context7.t7);

              _context7.t8 = console;
              _context7.t9 = "\u6D4B\u8BD5\uFF0C\u81EA\u589E\u6570\u5B57\uFF1A";
              _context7.next = 32;
              return _redisClient.incrAsync("incr_test_1");

            case 32:
              _context7.t10 = _context7.sent;
              _context7.t11 = _context7.t9.concat.call(_context7.t9, _context7.t10);

              _context7.t8.log.call(_context7.t8, _context7.t11);

              _context7.next = 37;
              return _redisClient.rpushAsync(key, JSON.stringify({
                send: (0, _moment["default"])().format(),
                time: 1
              }));

            case 37:
              _context7.next = 39;
              return _redisClient.expireAsync(key, 3);

            case 39:
              _context7.t12 = console;
              _context7.t13 = "\u6D4B\u8BD5\uFF0C\u5B58\u50A8\u5E76\u8BFB\u53D6\u5217\u8868\u7C7B\u578B\uFF0Credis key:".concat(key, ",value:");
              _context7.next = 43;
              return _redisClient.lrangeAsync("test", 0, -1);

            case 43:
              _context7.t14 = _context7.sent;
              _context7.t15 = _context7.t13 + _context7.t14;

              _context7.t12.log.call(_context7.t12, _context7.t15);

              _context7.next = 48;
              return _redisClient.delAsync('test');

            case 48:
              //
              resolve(_redisClient);

            case 49:
            case "end":
              return _context7.stop();
          }
        }, _callee7);
      }));

      return function onAuthDone() {
        return _ref7.apply(this, arguments);
      };
    }();

    _redisClient.on("connect",
    /*#__PURE__*/
    function () {
      var _ref8 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee9(err) {
        var _redisConfig3, password;

        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) switch (_context9.prev = _context9.next) {
            case 0:
              _redisConfig3 = _redisConfig, password = _redisConfig3.password;
              console.log("\u94FE\u63A5Redis\u670D\u52A1\u5668 on ".concat(_redisConfig.host, ":").concat(_redisConfig.port, " with password ").concat(password ? "*****" : "none", " ... ...connecting ...")); //

              if (!password) {
                _context9.next = 6;
                break;
              }

              _redisClient.auth(password,
              /*#__PURE__*/
              function () {
                var _ref9 = _asyncToGenerator(
                /*#__PURE__*/
                _regenerator["default"].mark(function _callee8(err, result) {
                  return _regenerator["default"].wrap(function _callee8$(_context8) {
                    while (1) switch (_context8.prev = _context8.next) {
                      case 0:
                        if (!err) {
                          _context8.next = 5;
                          break;
                        }

                        console.error("_redisClient.auth with password \u65F6\u5F02\u5E38\uFF1A".concat(err));
                        reject(err);
                        _context8.next = 7;
                        break;

                      case 5:
                        _context8.next = 7;
                        return onAuthDone();

                      case 7:
                      case "end":
                        return _context8.stop();
                    }
                  }, _callee8);
                }));

                return function (_x7, _x8) {
                  return _ref9.apply(this, arguments);
                };
              }());

              _context9.next = 8;
              break;

            case 6:
              _context9.next = 8;
              return onAuthDone();

            case 8:
            case "end":
              return _context9.stop();
          }
        }, _callee9);
      }));

      return function (_x6) {
        return _ref8.apply(this, arguments);
      };
    }());

    try {
      Object.keys(_redisClient).forEach(function (modelName) {
        if (modelName.indexOf("Async") !== -1 && typeof _redisClient[modelName] === "function" && _redisClient[modelName].length > 0) {
          _redisClient["".concat(modelName, "Orig")] = _redisClient[modelName];
          _redisClient[modelName] =
          /*#__PURE__*/
          _asyncToGenerator(
          /*#__PURE__*/
          _regenerator["default"].mark(function _callee10() {
            var _redisClient2;

            var _OrigModelName,
                _len,
                params,
                _key,
                _args10 = arguments;

            return _regenerator["default"].wrap(function _callee10$(_context10) {
              while (1) switch (_context10.prev = _context10.next) {
                case 0:
                  _OrigModelName = "".concat(modelName, "Orig");

                  for (_len = _args10.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
                    params[_key] = _args10[_key];
                  }

                  if (typeof params[0] === "string") {
                    params[0] = redis_cache_key_prefx + params[0];
                  }

                  _context10.next = 5;
                  return (_redisClient2 = _redisClient)[_OrigModelName].apply(_redisClient2, params);

                case 5:
                  return _context10.abrupt("return", _context10.sent);

                case 6:
                case "end":
                  return _context10.stop();
              }
            }, _callee10);
          }));
          var modelNameWithOutSpace = modelName.replace("Async", '') + 'WithOutSpaceAsync';
          _redisClient[modelNameWithOutSpace] =
          /*#__PURE__*/
          _asyncToGenerator(
          /*#__PURE__*/
          _regenerator["default"].mark(function _callee11() {
            var _redisClient3;

            var _OrigModelName,
                _args11 = arguments;

            return _regenerator["default"].wrap(function _callee11$(_context11) {
              while (1) switch (_context11.prev = _context11.next) {
                case 0:
                  _OrigModelName = "".concat(modelName, "Orig");
                  _context11.next = 3;
                  return (_redisClient3 = _redisClient)[_OrigModelName].apply(_redisClient3, _args11);

                case 3:
                  return _context11.abrupt("return", _context11.sent);

                case 4:
                case "end":
                  return _context11.stop();
              }
            }, _callee11);
          }));
        }
      });
    } catch (err) {
      console.error("_redisClient\u5F02\u6B65Promise\u5316\u9047\u5230\u9519\u8BEF\uFF1A".concat(err));
      reject(err);
    }
  });
};

var getRedisClient = function getRedisClient() {
  if (_redisClient) return _redisClient;

  if (!_redisConfig) {
    if (process.env.NODE_ENV === "production") {
      console.warn("redis\u914D\u7F6E\u4FE1\u606F\u5C1A\u672A\u8BBE\u7F6E\uFF08\u8BF7\u8C03\u7528setting_redisConfig\uFF09!!, Cacheable\u7B49\u7F13\u5B58\u4FEE\u9970\u5668\u5C06\u5931\u6548");
    } else {
      throw new Error("redis\u914D\u7F6E\u4FE1\u606F\u5C1A\u672A\u8BBE\u7F6E\uFF08\u8BF7\u8C03\u7528setting_redisConfig\uFF09");
    }
  }

  _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee12() {
    return _regenerator["default"].wrap(function _callee12$(_context12) {
      while (1) switch (_context12.prev = _context12.next) {
        case 0:
          _context12.next = 2;
          return _init_redisClient();

        case 2:
        case "end":
          return _context12.stop();
      }
    }, _callee12);
  }))();

  return _redisClient;
};
/***
 * 微信授权网关的保留方法，其他应用只可读取，严禁调用更新
 */


exports.getRedisClient = getRedisClient;

var __setGankaoWXAuthToken =
/*#__PURE__*/
function () {
  var _ref13 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee13(gkwxauthtoken, wxuserinfo) {
    return _regenerator["default"].wrap(function _callee13$(_context13) {
      while (1) switch (_context13.prev = _context13.next) {
        case 0:
          _context13.next = 2;
          return _redisClient.setAsyncOrig(gkwxauthtoken, wxuserinfo);

        case 2:
        case "end":
          return _context13.stop();
      }
    }, _callee13);
  }));

  return function __setGankaoWXAuthToken(_x9, _x10) {
    return _ref13.apply(this, arguments);
  };
}();

exports.__setGankaoWXAuthToken = __setGankaoWXAuthToken;