"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MultiProccessTaskThrottleV2 = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _redisClient = require("./redisClient");

var _util = require("./util");

var _nodeSchedule = _interopRequireDefault(require("node-schedule"));

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var NODE_APP_INSTANCE = process.env.NODE_APP_INSTANCE || '-';

var __Do = function __Do(_ref) {
  var name = _ref.name,
      func = _ref.func,
      _ref$durationSecond = _ref.durationSecond,
      durationSecond = _ref$durationSecond === void 0 ? 50 : _ref$durationSecond,
      onError = _ref.onError;
  //name： 定制任务在redis中标记的key的名称
  //func：schedule模块调用的函数
  //durationSecond：预计执行的周期，在这个周期内，确保只有一个进程在处理逻辑。类似一个锁的机制，注意，这个时长不能超过schedule定时周期，并建议比定时周期少10秒中
  //onError：发生错误时的回调函数
  if (typeof func !== "function") throw new Error("\u6307\u5B9A\u7684func\u53C2\u6570\u4E0D\u662F\u6709\u6548\u7684function\u7C7B\u578B\uFF0C\u8BF7\u68C0\u67E5");
  return (
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2() {
      var taskNameInCacheKey, timer_refreshTaskState, info_inside, __startTime, signal, re_signal, __endTime, refractory_period;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            console.log("[NODE_APP_INSTANCE=".concat(NODE_APP_INSTANCE, "] scheduleJob start >>>>>>>>").concat(new Date()));
            taskNameInCacheKey = name;
            timer_refreshTaskState = null;
            _context2.prev = 3;
            _context2.next = 6;
            return (0, _redisClient.getRedisClient)().getAsync(taskNameInCacheKey);

          case 6:
            info_inside = _context2.sent;
            if (info_inside) info_inside = JSON.parse(info_inside);

            if (info_inside) {
              _context2.next = 45;
              break;
            }

            __startTime = new Date().getTime();
            signal = {
              status: 'doing',
              starttime: (0, _moment["default"])(),
              flowID: Math.random(),
              updated_stamp: new Date().getTime()
            }; //假设执行期是50秒，考虑进程奔溃或异常清空导致无法更新不应期。

            _context2.t0 = console;
            _context2.next = 14;
            return (0, _redisClient.getRedisClient)().setAsync(taskNameInCacheKey, JSON.stringify(signal), 'EX', durationSecond);

          case 14:
            _context2.t1 = _context2.sent;

            _context2.t0.log.call(_context2.t0, _context2.t1);

            _context2.next = 18;
            return (0, _util.sleep)(2000);

          case 18:
            _context2.next = 20;
            return (0, _redisClient.getRedisClient)().getAsync(taskNameInCacheKey);

          case 20:
            re_signal = _context2.sent;
            if (re_signal) re_signal = JSON.parse(re_signal);

            if (!(re_signal.flowID !== signal.flowID)) {
              _context2.next = 25;
              break;
            }

            console.log("".concat(taskNameInCacheKey, "\u4EFB\u52A1\u9501\u62A2\u5360\u5931\u8D25\uFF0C\u4EA4\u7531\u522B\u4EBA\u6267\u884C\uFF0C\u4E2D\u65AD\uFF0C\u9000\u51FA\u4EFB\u52A1\uFF01")); //中断，退出

            return _context2.abrupt("return");

          case 25:
            //执行任务
            console.log("".concat(taskNameInCacheKey, "\u4EFB\u52A1\u9501\u62A2\u5360\u6210\u529F\uFF0C\u8FDB\u5165\u6267\u884C\u72B6\u6001..."));
            timer_refreshTaskState = setInterval(
            /*#__PURE__*/
            _asyncToGenerator(
            /*#__PURE__*/
            _regenerator["default"].mark(function _callee() {
              var __endTime, remain;

              return _regenerator["default"].wrap(function _callee$(_context) {
                while (1) switch (_context.prev = _context.next) {
                  case 0:
                    signal.updated_stamp = new Date().getTime();
                    __endTime = new Date().getTime();
                    remain = Math.max(10, durationSecond - Math.floor((__endTime - __startTime) / 1000));
                    _context.next = 5;
                    return (0, _redisClient.getRedisClient)().setAsync(taskNameInCacheKey, JSON.stringify(signal), 'EX', remain);

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }, _callee);
            })), 10 * 1000);
            _context2.next = 29;
            return func();

          case 29:
            // 计算本周期内剩余的不应期时长，写入redis
            __endTime = new Date().getTime();
            refractory_period = 0;

            if (!(durationSecond - Math.floor((__endTime - __startTime) / 1000) > 0)) {
              _context2.next = 40;
              break;
            }

            refractory_period = Math.max(10, durationSecond - Math.floor((__endTime - __startTime) / 1000));
            console.log("\u4EFB\u52A1".concat(taskNameInCacheKey, "\u6267\u884C\u8017\u65F6\uFF1A").concat(__endTime - __startTime, "\u6BEB\u79D2\uFF0C\u5269\u4F59\u4E0D\u5E94\u671F\uFF1A").concat(refractory_period, "\u79D2")); //更改信号量

            signal.status = 'done';
            signal.expiretime = signal.starttime.add(durationSecond, 'second');
            _context2.next = 38;
            return (0, _redisClient.getRedisClient)().setAsync(taskNameInCacheKey, JSON.stringify(signal), 'EX', refractory_period);

          case 38:
            _context2.next = 42;
            break;

          case 40:
            _context2.next = 42;
            return (0, _redisClient.getRedisClient)().delAsync(taskNameInCacheKey);

          case 42:
            if (timer_refreshTaskState) {
              clearInterval(timer_refreshTaskState);
            }

            _context2.next = 53;
            break;

          case 45:
            console.log('info_inside:', JSON.stringify(info_inside)); //检查下任务的新鲜度，如果有陈旧的标记位，说明当时的任务执行者长久未刷新任务状态，应该已经挂掉了,把标记位直接删除

            if (!(info_inside && info_inside.updated_stamp < new Date().getTime() - 30 * 1000)) {
              _context2.next = 52;
              break;
            }

            console.log("".concat(taskNameInCacheKey, "\u4EFB\u52A1\u72B6\u6001\u957F\u4E45\u672A\u66F4\u65B0\uFF08\u4E0A\u4E00\u4E2A\u4EFB\u52A1\u6267\u884C\u8005\u5DF2\u7ECF'\u6302\u6389\u4E86'\uFF09\uFF0C\u76F4\u63A5\u5220\u9664\u4EFB\u52A1\u6807\u8BB0\u4F4D\uFF0C\u786E\u4FDD\u4E0B\u4E00\u4E2A\u4E8B\u4EF6\u5468\u671F\u65F6\u5927\u5BB6\u53EF\u4EE5\u6B63\u5E38\u7ADE\u6807..."));
            _context2.next = 50;
            return (0, _redisClient.getRedisClient)().delAsync(taskNameInCacheKey);

          case 50:
            _context2.next = 53;
            break;

          case 52:
            console.log("".concat(taskNameInCacheKey, "\u4EFB\u52A1\uFF0C\u522B\u4EBA\u5728\u6267\u884C\uFF0C\u6211\u8DF3\u8FC7..."));

          case 53:
            _context2.next = 65;
            break;

          case 55:
            _context2.prev = 55;
            _context2.t2 = _context2["catch"](3);
            _context2.next = 59;
            return (0, _redisClient.getRedisClient)().delAsync(taskNameInCacheKey);

          case 59:
            if (!(typeof onError === "function")) {
              _context2.next = 64;
              break;
            }

            _context2.next = 62;
            return onError({
              name: name,
              func: func,
              durationSecond: durationSecond
            }, _context2.t2);

          case 62:
            _context2.next = 65;
            break;

          case 64:
            console.error(_context2.t2);

          case 65:
          case "end":
            return _context2.stop();
        }
      }, _callee2, null, [[3, 55]]);
    }))
  );
};
/**
 * cluster多线程环境下的定时任务执行器，内部带有互斥的锁机制，确保同一时间不会并发处理，依赖于redis来存储锁状态
 * @param schedulePlan  任务的执行周期/频率，内部传递给schedule.scheduleJob, 默认是每1分钟的第一秒开始执行一次（1 *\/1 * * * *）
 * @param name  任务的名称，唯一，也会用作在redis中保存的锁信息的key名称
 * @param func  回调函数
 * @param durationSecond    整体不应期，默认是50秒，计划任务循环周期必须大于此时间值
 * @param onError   捕获错误的自定义函数
 * @returns {Function}
 * @constructor
 */


var MultiProccessTaskThrottleV2 = function MultiProccessTaskThrottleV2(_ref4) {
  var _ref4$schedulePlan = _ref4.schedulePlan,
      schedulePlan = _ref4$schedulePlan === void 0 ? '1 */1 * * * *' : _ref4$schedulePlan,
      name = _ref4.name,
      func = _ref4.func,
      _ref4$durationSecond = _ref4.durationSecond,
      durationSecond = _ref4$durationSecond === void 0 ? 50 : _ref4$durationSecond,
      onError = _ref4.onError;
  var option = {
    name: name,
    func: func,
    durationSecond: durationSecond,
    onError: onError
  };
  return _nodeSchedule["default"].scheduleJob(schedulePlan, __Do(option));
};

exports.MultiProccessTaskThrottleV2 = MultiProccessTaskThrottleV2;