"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CreateListenRouter = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _express = _interopRequireWildcard(require("express"));

var _lodash = require("lodash");

var _url = _interopRequireDefault(require("url"));

var _jaegerClient = require("jaeger-client");

var _path = _interopRequireDefault(require("path"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var router = new _express.Router();
var isDeveloping = process.env.NODE_ENV === 'development';
var alitracer;
var jaegerconfig;

if (!isDeveloping) {
  var tag = process.env.PRODUCTION_TYPE === "production" ? "prod" : "test";
  jaegerconfig = {
    serviceName: function () {
      return require(_path["default"].join(process.cwd(), 'package.json')).name;
    }(),
    sampler: {
      type: "const",
      param: 1
    },
    reporter: {
      collectorEndpoint: "http://tracing-analysis-dc-hz-internal.aliyuncs.com/adapt_a5um63wkgi@21f512feeb00b10_a5um63wkgi@53df7ad2afe8301_".concat(tag, "/api/traces")
    }
  };
  alitracer = (0, _jaegerClient.initTracer)(jaegerconfig);
} else {
  console.warn('DEV开发环境，自动关闭阿里云链路跟踪（jaeger-client）');
}

var router_listen_created = false; // let apiLimiter = new RateLimit({
//     windowMs: 15*60*1000, // 15 minutes
//     max: 1000,
//     statusCode:200,
//     delayMs: 0, // disabled,
//     handler:function (req, res, next) {
//         res.json({err: '请求过于频繁，请稍后重试', result:''})
//     }
// });
// {req,res,result}

var _bindRouter =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee3(BusinessModel, fn_beforeCall, fn_afterCall, frontpage_default) {
    var resWrap, result, _BusinessModel, _frontpage_default, router;

    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!fn_beforeCall) {
              _context3.next = 3;
              break;
            }

            if (!(typeof fn_beforeCall !== 'function')) {
              _context3.next = 3;
              break;
            }

            throw new Error('fn_beforeCall必须是function类型的参数');

          case 3:
            if (!fn_afterCall) {
              _context3.next = 6;
              break;
            }

            if (!(typeof fn_afterCall !== 'function')) {
              _context3.next = 6;
              break;
            }

            throw new Error('可选参数fn_afterCall必须是function类型的参数');

          case 6:
            resWrap =
            /*#__PURE__*/
            function () {
              var _ref3 = _asyncToGenerator(
              /*#__PURE__*/
              _regenerator["default"].mark(function _callee(_ref2) {
                var req, result;
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        req = _ref2.req, result = _ref2.result;

                        if (!fn_afterCall) {
                          _context.next = 7;
                          break;
                        }

                        _context.next = 4;
                        return fn_afterCall({
                          req: req,
                          result: result
                        });

                      case 4:
                        _context.t0 = _context.sent;
                        _context.next = 8;
                        break;

                      case 7:
                        _context.t0 = result;

                      case 8:
                        return _context.abrupt("return", _context.t0);

                      case 9:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function resWrap(_x5) {
                return _ref3.apply(this, arguments);
              };
            }();

            _BusinessModel = BusinessModel;
            _frontpage_default = frontpage_default;
            router = _express["default"].Router(); //开放get请求方式（注意：此时无法head传值）
            // router.get('*', async function (req, res, next) {
            //     res.json({err: 'get请求方式未实现, 仅限Post方式', result: null});
            // });

            router.all('*',
            /*#__PURE__*/
            function () {
              var _ref4 = _asyncToGenerator(
              /*#__PURE__*/
              _regenerator["default"].mark(function _callee2(req, res, next) {
                var pathItems, methodName, source, _source$queryObj, queryObj, params, paramsMerged, modelSetting, apipath, inner_result, _result, __redirected, __customResp, msg, retData;

                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.prev = 0;
                        pathItems = req.path.split("/");
                        methodName = pathItems[1] ? pathItems[1] : null;

                        if (_BusinessModel[methodName]) {
                          _context2.next = 5;
                          break;
                        }

                        throw new Error("api\u8BF7\u6C42\u7684\u5730\u5740(".concat(req.originalUrl, ")\u4E2D\u5BF9\u5E94\u7684\u7C7B(").concat(_BusinessModel.name, ")\u4E0D\u5B58\u5728").concat(methodName, "\u65B9\u6CD5,\u8BF7\u786E\u8BA4\u6620\u5C04\u7684\u7C7B\u662F\u5426\u6B63\u786E!"));

                      case 5:
                        if (!(!req.body && !res.query)) {
                          _context2.next = 7;
                          break;
                        }

                        throw new Error("api\u8BF7\u6C42\u4E2D\u7684body\u548Cquery\u90FD\u4E3A\u7A7A\uFF0C\u6CA1\u6709\u63D0\u4EA4\u5185\u5BB9\u4F20\u5165!");

                      case 7:
                        //queryObj是对早期传值方式的兼容（早期会将所有参数包裹在queryObj属性里）
                        source = req.method === 'POST' ? req.body : req.query;
                        _source$queryObj = source.queryObj, queryObj = _source$queryObj === void 0 ? source : _source$queryObj;
                        params = queryObj;
                        paramsMerged = null;
                        params.___frontpageURL = _url["default"].parse(req.headers['frontpage'] || _frontpage_default || '');

                        if (!(fn_beforeCall && typeof fn_beforeCall === 'function')) {
                          _context2.next = 25;
                          break;
                        }

                        //如果有要对传入参数做验证，则在fn_beforeCall中处理
                        modelSetting = _BusinessModel.__modelSetting ? _BusinessModel.__modelSetting() : {};
                        apipath = "".concat(_BusinessModel.name, ".").concat(req.path);
                        _context2.next = 17;
                        return fn_beforeCall({
                          apipath: apipath,
                          req: req,
                          res: res,
                          params: params,
                          modelSetting: modelSetting
                        });

                      case 17:
                        paramsMerged = _context2.sent;

                        if (!(paramsMerged && typeof paramsMerged === 'function')) {
                          _context2.next = 25;
                          break;
                        }

                        _context2.t0 = res;
                        _context2.next = 22;
                        return paramsMerged();

                      case 22:
                        _context2.t1 = _context2.sent;

                        _context2.t0.json.call(_context2.t0, _context2.t1);

                        return _context2.abrupt("return");

                      case 25:
                        _context2.next = 27;
                        return _BusinessModel[methodName](_objectSpread2(_objectSpread2({}, paramsMerged || params), {}, {
                          req: req,
                          res: res
                        }));

                      case 27:
                        result = _context2.sent;

                        if (!(typeof result === "function")) {
                          _context2.next = 40;
                          break;
                        }

                        inner_result = result();

                        if (!(_typeof(inner_result) === "object")) {
                          _context2.next = 38;
                          break;
                        }

                        _context2.t2 = res;
                        _context2.next = 34;
                        return resWrap({
                          req: req,
                          res: res,
                          result: inner_result
                        });

                      case 34:
                        _context2.t3 = _context2.sent;

                        _context2.t2.json.call(_context2.t2, _context2.t3);

                        _context2.next = 39;
                        break;

                      case 38:
                        res.end((inner_result || '').toString());

                      case 39:
                        return _context2.abrupt("return");

                      case 40:
                        if (!(_typeof(result) !== "object" || (0, _lodash.keys)(result).length === 0)) {
                          _context2.next = 42;
                          break;
                        }

                        throw new Error("\u63A5\u53E3\u8FD4\u56DE\u503C\u5FC5\u987B\u5305\u542Bkey\uFF0Fvalue\u7ED3\u6784\uFF08\u56E0\u6B64\u4E5F\u4E0D\u80FD\u4E3Anull\u503C\uFF09\uFF0C\u63A5\u53E3".concat(req.originalUrl, "\u7C7B\u7684").concat(methodName, "\u65B9\u6CD5\u8FD4\u56DE\u7684\u6570\u636E\u7ED3\u6784\u4E0D\u5177\u6709key/value\u7ED3\u6784\uFF0C\u8BF7\u9002\u914D\u8C03\u6574\u4EE5\u7B26\u5408\u89C4\u8303!"));

                      case 42:
                        //API方法内部做了重定向，或者自操作res输出
                        _result = result, __redirected = _result.__redirected, __customResp = _result.__customResp;

                        if (!(__redirected || __customResp)) {
                          _context2.next = 45;
                          break;
                        }

                        return _context2.abrupt("return");

                      case 45:
                        if (result) {
                          _context2.next = 50;
                          break;
                        }

                        msg = "\u63A5\u53E3\u8FD4\u56DE\u503C\u5FC5\u987B\u5305\u542Bkey\uFF0Fvalue\u7ED3\u6784\uFF08\u56E0\u6B64\u4E5F\u4E0D\u80FD\u4E3Anull\u503C\uFF09\uFF0C\u63A5\u53E3".concat(req.originalUrl, "\u7C7B\u7684").concat(methodName, "\u65B9\u6CD5\u8FD4\u56DE\u7684\u6570\u636E\u7ED3\u6784\u4E0D\u5177\u6709key/value\u7ED3\u6784\uFF0C\u8BF7\u9002\u914D\u8C03\u6574\u4EE5\u7B26\u5408\u89C4\u8303!");
                        console.error(msg);

                        if (!(process.env.NODE_ENV !== "production")) {
                          _context2.next = 50;
                          break;
                        }

                        throw new Error(msg);

                      case 50:
                        retData = {
                          err: null,
                          result: result
                        };
                        _context2.t4 = res;
                        _context2.next = 54;
                        return resWrap({
                          req: req,
                          res: res,
                          result: retData
                        });

                      case 54:
                        _context2.t5 = _context2.sent;

                        _context2.t4.json.call(_context2.t4, _context2.t5);

                        if (process.env.NODE_ENV !== "production" && process.env.PRINT_API_RESULT === "1") {
                          console.log("api call result from(".concat(req.originalUrl, "):").concat(JSON.stringifyline(retData)));
                        }

                        _context2.next = 75;
                        break;

                      case 59:
                        _context2.prev = 59;
                        _context2.t6 = _context2["catch"](0);

                        if (process.env.NODE_ENV !== "production") {
                          //region 让错误直接抛出，并终止程序。不需要时可以整体注释掉
                          // console.dir(`这里：除了程序逻辑级别的Exception错误，在非正式环境会终止程序，便于调试排查。不需要时可以找到我的位置并注释掉`);
                          // if (!err._gankao || process.env.StopOnAnyException == '1') {
                          //     //通过timeout排除错误，会导致程序终止
                          //     setTimeout(() => {
                          //         throw err;
                          //     });
                          // } else {
                          //     //程序逻辑级别的Exception，输出到控制台即可
                          // }
                          console.error(_context2.t6);

                          if (process.env.NODE_ENV !== "production") {
                            console.error(_context2.t6.stack);
                          } //endregion

                        } else {
                          console.error(_context2.t6);
                        }

                        if (!(process.env.NODE_ENV !== "production")) {
                          _context2.next = 70;
                          break;
                        }

                        _context2.t7 = res;
                        _context2.next = 66;
                        return resWrap({
                          req: req,
                          res: res,
                          result: {
                            err: _objectSpread2(_objectSpread2({}, _context2.t6), {}, {
                              message: _context2.t6.message,
                              stack: _context2.t6.stack
                            }),
                            result: null
                          }
                        });

                      case 66:
                        _context2.t8 = _context2.sent;

                        _context2.t7.json.call(_context2.t7, _context2.t8);

                        _context2.next = 75;
                        break;

                      case 70:
                        _context2.t9 = res;
                        _context2.next = 73;
                        return resWrap({
                          req: req,
                          res: res,
                          result: {
                            err: _objectSpread2(_objectSpread2({}, _context2.t6), {}, {
                              message: _context2.t6.message
                            }),
                            result: null
                          }
                        });

                      case 73:
                        _context2.t10 = _context2.sent;

                        _context2.t9.json.call(_context2.t9, _context2.t10);

                      case 75:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, null, [[0, 59]]);
              }));

              return function (_x6, _x7, _x8) {
                return _ref4.apply(this, arguments);
              };
            }());
            return _context3.abrupt("return", router);

          case 12:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function _bindRouter(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

var middle_gkAliTracer = function middle_gkAliTracer(req, res, next) {
  if (alitracer) {
    try {
      req.span = alitracer.startSpan(req.originalUrl);
      req.span.log({
        event: "timestamp",
        value: Date.now()
      });
    } catch (e) {
      console.error(e.stack);
    }

    next();

    try {
      req.span.finish();
    } catch (e) {
      console.error(e.stack);
    }
  } else {
    next();
  }
};

var CreateListenRouter =
/*#__PURE__*/
function () {
  var _ref5 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee5(options) {
    var apiroot, modelClasses, beforeCall, afterCall, method404, frontpage_default, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, classObj, model, as, aPath;

    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            if (!router_listen_created) {
              _context5.next = 2;
              break;
            }

            return _context5.abrupt("return", router);

          case 2:
            apiroot = options.apiroot, modelClasses = options.modelClasses, beforeCall = options.beforeCall, afterCall = options.afterCall, method404 = options.method404, frontpage_default = options.frontpage_default;
            console.log('api root :', apiroot); //router.use(apiLimiter);

            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context5.prev = 7;
            _iterator = modelClasses[Symbol.iterator]();

          case 9:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context5.next = 39;
              break;
            }

            classObj = _step.value;

            if (!(typeof classObj === "function")) {
              _context5.next = 22;
              break;
            }

            _context5.t0 = router;
            _context5.t1 = "/".concat(classObj.name.toLowerCase());
            _context5.t2 = middle_gkAliTracer;
            _context5.next = 17;
            return _bindRouter(classObj, beforeCall, afterCall);

          case 17:
            _context5.t3 = _context5.sent;

            _context5.t0.use.call(_context5.t0, _context5.t1, _context5.t2, _context5.t3);

            console.log("mapped class '".concat(classObj.name, "' to '").concat(apiroot).concat(classObj.name.toLowerCase(), "/*' ... OK!"));
            _context5.next = 36;
            break;

          case 22:
            model = classObj.model, as = classObj.as;

            if (!(model && as)) {
              _context5.next = 35;
              break;
            }

            aPath = (as || model.name).toLowerCase();
            _context5.t4 = router;
            _context5.t5 = "/".concat(aPath);
            _context5.t6 = middle_gkAliTracer;
            _context5.next = 30;
            return _bindRouter(model, beforeCall, afterCall, frontpage_default);

          case 30:
            _context5.t7 = _context5.sent;

            _context5.t4.use.call(_context5.t4, _context5.t5, _context5.t6, _context5.t7);

            console.log("mapped class '".concat(model.name, "' to '").concat(apiroot).concat(aPath, "/*' ... OK!"));
            _context5.next = 36;
            break;

          case 35:
            throw new Error("modelClasses\u53C2\u6570\u4E2D".concat(classObj, "\u7684\u5BF9\u8C61\u4E0D\u662F\u6709\u6548\u7684Class\u7C7B\u6216{model,as}\u7ED3\u6784\u5B9A\u4E49"));

          case 36:
            _iteratorNormalCompletion = true;
            _context5.next = 9;
            break;

          case 39:
            _context5.next = 45;
            break;

          case 41:
            _context5.prev = 41;
            _context5.t8 = _context5["catch"](7);
            _didIteratorError = true;
            _iteratorError = _context5.t8;

          case 45:
            _context5.prev = 45;
            _context5.prev = 46;

            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
              _iterator["return"]();
            }

          case 48:
            _context5.prev = 48;

            if (!_didIteratorError) {
              _context5.next = 51;
              break;
            }

            throw _iteratorError;

          case 51:
            return _context5.finish(48);

          case 52:
            return _context5.finish(45);

          case 53:
            //API的存活探针
            router.all('/helloworld', function (req, res, next) {
              console.log('hello ... ');
              res.end('hello');
            }); //API的存活探针

            router.all('/_hello', function (req, res, next) {
              console.log('hello ... ');
              res.end('hello');
            }); //拦截未匹配到的其他方法

            router.all('*',
            /*#__PURE__*/
            function () {
              var _ref6 = _asyncToGenerator(
              /*#__PURE__*/
              _regenerator["default"].mark(function _callee4(req, res, next) {
                var retObj;
                return _regenerator["default"].wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.prev = 0;

                        if (!(typeof method404 === 'function')) {
                          _context4.next = 6;
                          break;
                        }

                        _context4.next = 4;
                        return method404(req, res);

                      case 4:
                        _context4.next = 7;
                        break;

                      case 6:
                        if (process.env.NODE_ENV === "production") {
                          res.status = 404;
                          res.json({
                            err: 'API Not Defined!',
                            result: null
                          });
                        } else {
                          retObj = {
                            err: "API\u65B9\u6CD5\u672A\u5B9A\u4E49(".concat(req.path, ", \u8BF7\u786E\u8BA4\u7C7B\u662F\u5426\u5B58\u5728\u6216\u7C7B\u7684\u540D\u79F0\u662F\u5426\u6709\u53D8\u66F4\uFF01)"),
                            result: null
                          };
                          console.error(JSON.stringify(retObj));
                          res.json(retObj);
                        }

                      case 7:
                        _context4.next = 13;
                        break;

                      case 9:
                        _context4.prev = 9;
                        _context4.t0 = _context4["catch"](0);
                        res.status = 404;
                        res.json({
                          err: "404\u5904\u7406\u9519\u8BEF(".concat(JSON.stringify(_context4.t0), ")"),
                          result: null
                        });

                      case 13:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4, null, [[0, 9]]);
              }));

              return function (_x10, _x11, _x12) {
                return _ref6.apply(this, arguments);
              };
            }());
            router_listen_created = true;
            return _context5.abrupt("return", router);

          case 58:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, null, [[7, 41, 45, 53], [46,, 48, 52]]);
  }));

  return function CreateListenRouter(_x9) {
    return _ref5.apply(this, arguments);
  };
}();

exports.CreateListenRouter = CreateListenRouter;