"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadEnvFile = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _dotenv = _interopRequireDefault(require("dotenv"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var loadEnvFile = function loadEnvFile() {
  var env_name = process.env.PRODUCTION_TYPE || 'development';
  var process_cwd = process.cwd();
  console.log("[dotenv] process.env.PRODUCTION_TYPE = " + env_name);

  if (env_name === "production") {
    console.log("[dotenv] detecting ... /.env(.production) ");

    if (_fs["default"].existsSync(process_cwd + '/.env')) {
      _dotenv["default"].config({
        path: process_cwd + '/.env'
      });

      console.log("[dotenv] detecting ... /.env    success!");
    } else if (_fs["default"].existsSync(process_cwd + '/.env.production')) {
      _dotenv["default"].config({
        path: process_cwd + '/.env.production'
      });

      console.log("[dotenv] detecting ... /.env.production  success!");
    }
  } else if (env_name === "test") {
    console.log("[dotenv] detecting ... /.env.test ");

    if (_fs["default"].existsSync(process_cwd + '/.env.test')) {
      _dotenv["default"].config({
        path: process_cwd + '/.env.test'
      });

      console.log("[dotenv] detecting ... /.env.test    success!");
    }
  } else {
    console.log("[dotenv] detecting ... /.env.development ");

    if (_fs["default"].existsSync(process_cwd + '/.env.development')) {
      _dotenv["default"].config({
        path: process_cwd + '/.env.development'
      });

      console.log("[dotenv] detecting ... /.env.development    success!");
    }
  }
};

exports.loadEnvFile = loadEnvFile;