"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CurrentResult = exports.CRUserInfo = exports.CRTeacher_Teach = exports.CRPartner = void 0;

var _require = require('nexus'),
    objectType = _require.objectType;

var CRPartner = objectType({
  name: 'CRPartner',
  description: '机构摘要信息',
  definition: function definition(t) {
    t["int"]('id');
    t.string('name', {
      description: "机构的名称"
    });
    t.string('ename', {
      description: '机构的简码'
    });
    t.nullable.string('settings', {
      description: '机构的扩展配置信息，通常是UI界面层配置，重要的功能性配置另开表字段来记录'
    });
    t["boolean"]('released', {
      description: '是否正式商业运营（结束了开发调试期）'
    });
    t.nullable.string('created_at', {
      description: '创建实际'
    });
    t.nullable.string('subdomain', {
      description: '自定义一级域名'
    });
    t.nullable["int"]('orgType', {
      description: '加盟馆类型：1、合作型；2、加盟馆；3、教育局；4、校园代理型'
    });
    t.nullable["int"]('aimodel', {
      description: 'ai测评的版本，1为旧版；2为新版'
    });
    t.nullable["int"]('useJiamengSelfLogo', {
      description: '是否采用了自定义品牌定制'
    });
  }
});
exports.CRPartner = CRPartner;
var CRTeacher_Teach = objectType({
  name: 'CRTeacher_Teach',
  description: '老师的授课学校与科目',
  definition: function definition(t) {
    t.nullable["int"]('grade_id', {
      description: '教授的学段，这里是年级表示法，13小学，14初中、15高中'
    });
    t.nullable.string('gradeName', {
      description: '学段的名称'
    });
    t.nullable["int"]('subject_id', {
      description: '科目的id，赶考制'
    });
    t.nullable.string('subjectName', {
      description: '科目的名称'
    });
  }
});
exports.CRTeacher_Teach = CRTeacher_Teach;
var CRUserInfo = objectType({
  name: 'CRUserInfo',
  description: '机构信息',
  definition: function definition(t) {
    t["int"]('gankaoUID');
    t["int"]('user_type');
    t["int"]('status');
    t.nullable["int"]('grade');
    t.nullable["int"]('partner_id');
    t.nullable["int"]('channel_id');
    t.nullable.string('mobile');
    t.nullable.string('real_name');
    t.nullable.string('logo');
    t.nullable.string('user_channel');
    t.nullable.string('uniqueid');
    t.nullable.string('real_openid');
    t.nullable.string('winxin_miniprog_openID');
    t.nullable["boolean"]('subscribed_gkzy');
    t.nullable.field('teacher_teach', {
      type: CRTeacher_Teach
    });
  }
});
exports.CRUserInfo = CRUserInfo;
var CurrentResult = objectType({
  name: 'CurrentResult',
  description: '当前状态（用户与渠道）',
  definition: function definition(t) {
    t.nullable["int"]('gankaoUID');
    t.nullable.field('crpartner', {
      type: CRPartner
    });
    t.nullable.string('crpartner_error');
    t.nullable.field('cruserInfo', {
      type: CRUserInfo
    });
    t.nullable.string('cruserInfo_error');
  }
});
exports.CurrentResult = CurrentResult;